.TH gen_udp 3 "kernel  2.13.3" "Ericsson AB" "ERLANG MODULE DEFINITION"
.SH MODULE
gen_udp \- Interface to UDP sockets
.SH DESCRIPTION
.LP
The \fIgen_udp\fR module provides functions for communicating with sockets using the UDP protocol\&.

.SH DATA TYPES

.nf
ip_address()
  see inet(3)

posix()
  see inet(3)

socket()
  as returned by open/1,2
.fi
.SH EXPORTS
.LP
.B
open(Port) -> {ok, Socket} | {error, Reason}
.br
.B
open(Port, Options) -> {ok, Socket} | {error, Reason}
.br
.RS
.TP
Types
Port = 0\&.\&.65535
.br
Options = [Opt]
.br
 Opt -- see below
.br
Socket = socket()
.br
Reason = posix()
.br
.RE
.RS
.LP
Associates a UDP port number (\fIPort\fR) with the calling process\&.
.LP
The available options are:
.RS 2
.TP 4
.B
\fIlist\fR:
Received \fIPacket\fR is delivered as a list\&.
.TP 4
.B
\fIbinary\fR:
Received \fIPacket\fR is delivered as a binary\&.
.TP 4
.B
\fI{ip, ip_address()}\fR:
If the host has several network interfaces, this option specifies which one to use\&.
.TP 4
.B
\fI{fd, int()}\fR:
If a socket has somehow been opened without using \fIgen_udp\fR, use this option to pass the file descriptor for it\&.
.TP 4
.B
\fIinet6\fR:
Set up the socket for IPv6\&.
.TP 4
.B
\fIinet\fR:
Set up the socket for IPv4\&.
.TP 4
.B
\fIOpt\fR:
See inet:setopts/2\&.
.RE
.LP
The returned socket \fISocket\fR is used to send packets from this port with \fIsend/4\fR\&. When UDP packets arrive at the opened port, they are delivered as messages:

.nf
{udp, Socket, IP, InPortNo, Packet}
.fi
.LP
Note that arriving UDP packets that are longer than the receive buffer option specifies, might be truncated without warning\&.
.LP
\fIIP\fR and \fIInPortNo\fR define the address from which \fIPacket\fR came\&. \fIPacket\fR is a list of bytes if the option \fIlist\fR was specified\&. \fIPacket\fR is a binary if the option \fIbinary\fR was specified\&.
.LP
Default value for the receive buffer option is \fI{recbuf, 8192}\fR\&.
.LP
If \fIPort == 0\fR, the underlying OS assigns a free UDP port, use \fIinet:port/1\fR to retrieve it\&.
.RE
.LP
.B
send(Socket, Address, Port, Packet) -> ok | {error, Reason}
.br
.RS
.TP
Types
Socket = socket()
.br
Address = string() | atom() | ip_address()
.br
Port = 0\&.\&.65535
.br
Packet = [char()] | binary()
.br
Reason = not_owner | posix()
.br
.RE
.RS
.LP
Sends a packet to the specified address and port\&. The \fIAddress\fR argument can be either a hostname, or an IP address\&.
.RE
.LP
.B
recv(Socket, Length) -> {ok, {Address, Port, Packet}} | {error, Reason}
.br
.B
recv(Socket, Length, Timeout) -> {ok, {Address, Port, Packet}} | {error, Reason}
.br
.RS
.TP
Types
Socket = socket()
.br
Length = int()
.br
Address = ip_address()
.br
Port = 0\&.\&.65535
.br
Packet = [char()] | binary()
.br
Timeout = int() | infinity
.br
Reason = not_owner | posix()
.br
.RE
.RS
.LP
This function receives a packet from a socket in passive mode\&.
.LP
The optional \fITimeout\fR parameter specifies a timeout in milliseconds\&. The default value is \fIinfinity\fR\&.
.RE
.LP
.B
controlling_process(Socket, Pid) -> ok
.br
.RS
.TP
Types
Socket = socket()
.br
Pid = pid()
.br
.RE
.RS
.LP
Assigns a new controlling process \fIPid\fR to \fISocket\fR\&. The controlling process is the process which receives messages from the socket\&.
.RE
.LP
.B
close(Socket) -> ok | {error, Reason}
.br
.RS
.TP
Types
Socket = socket()
.br
Reason = not_owner | posix()
.br
.RE
.RS
.LP
Closes a UDP socket\&.
.RE
